;; Dictionary entry
	struc	dictent
.n	resd	1	;; next
; .l	resd	1	;; left link
; .r	resd	1	;; right link
.flags	resd	1	;; Type/flags
.size	resd	1	;; Size (until ohdr takes over..)
.obj	resd	1	;; Pointer to ohdr (or OID?) (or addr)
.namel	resd	1	;; length of name string
.name	;; Beginning of string
	;; ...
	endstruc


	SECTION .text
init_dict:
	call	init_salloc
	ret


insert:		;; ( name namelen addr size flags -- )
	mpush	eax, ecx, esi, edi
	mov	eax, dictent.name + 1	;; Allocate (dictent.name + namelen + 1)
	add	eax, S(3)
	DPUSH	eax
	call	salloc
	DPOP	edi			;; edi = dictent
;phex edi
;pstr S(4)
;cr
	or	edi, edi
	jz	.err
	cld
	mov	eax, [dict]		;; insert dictent in list
	mov	[dict], edi
	stosd
	DPOP	eax	;flags
	stosd
	DPOP	eax	;size
	stosd
	DPOP	eax	;addr (obj)
	stosd
	DPOP	ecx	;namelen
	mov	eax, ecx
	stosd
	DPOP	esi	;name
	rep	movsb			;; copy string
	xor	al, al
	stosb				;; add terminating null
.err	mpop	eax, ecx, esi, edi
	ret


isearch: 	;; unimplemented; same as search for now...

search:		;; ( c-addr u -- size flags addr | 0 )
	mpush	eax, esi
	mov	esi, [dict]
	jmp short .1
.next	mov	esi, [esi+dictent.n]
.1	or	esi, esi
	jz	.fail
	lea	eax, [esi+dictent.name]
;cr
;pstr	eax
	;; Compare
	call	_2DUP
	DPUSH	eax
	MDPUSH	[esi+dictent.namel]
	call	strcmp
	DPOP	eax
	or	eax, eax
	jz	.next
	;; Match found!
	DROP2
	MDPUSH	[esi+dictent.size]
	MDPUSH	[esi+dictent.flags]
	MDPUSH	[esi+dictent.obj]
;pchr '*'
	jmp short .end
.fail	DROP2
	DPUSH	0
.end	mpop	eax, esi
	ret


strcmp:		;; ( str1 str2 -- 0 | -1 )
		;; str = c-addr u
	mpush	ecx, esi, edi
	DPOP	ecx
	call	SWAP
	DPOP	esi
	cmp	esi, ecx	;Do sizes match?
	jne	.sizediff
	;; Now on stack: addr1 addr2
	DPOP	esi
	DPOP	edi
	cld
	repe	cmpsb
	jne	.nomatch
	DPUSH	-1		;Matched!
	jmp short .end
.sizediff
	call	_2DROP
.nomatch
	DPUSH	0
.end	mpop	ecx, esi, edi
	ret


stricmp:	;; ( str1 str2 -- 0 | -1 )
	ret


chflags:
	ret


	SECTION .data
dict	dd	0		;; List head



	SECTION .text
;;
;; Small-block allocation routines
;;
	struc	memblock
.next	resd	1
.size	resd	1
	endstruc


init_salloc:
	mov	[freelist], dword SALLOC_START+8
	mov	[usedlist], dword 0
	mov	ebx, SALLOC_START+8
	mov	[ebx+memblock.size], dword SALLOC_SIZE-8
	mov	[ebx+memblock.next], dword 0
	ret


salloc:		;; ( size -- addr | 0 )
	mov	ecx, S(0)			;size required
	test	ecx, 3	;aligned if first 2 bits are 0
	jz	.aligned
	and	ecx, ~3
	add	ecx, 4
.aligned
	mov	edi, freelist
.next	mov	esi, edi			;esi = previous
	mov	edi, [edi+memblock.next]	;edi = current
	or	edi, edi
	jz	.fail
.1	mov	edx, [edi+memblock.size]	;edx = size of block
	cmp	edx, ecx			;big enough?
	jb	.next

	;; Found one...
	lea	eax, [edx-8]
	sub	eax, ecx			;eax = size of remainder
	cmp	eax, MIN_BLOCKSIZE		;large enough to split?
	jb	.small

	;; Split...
	mov	[edi+8+ecx+memblock.size], eax	;store size of remainder
	mov	ebx, [edi+memblock.next]	;link remainder -> next
	mov	[edi+8+ecx+memblock.next], ebx
	lea	ebx, [edi+8+ecx]		;ebx = remainder
	jmp short .link
.small	mov	ebx, [edi+memblock.next]	;ebx = next

.link	mov	[esi+memblock.next], ebx	;link prevous -> ebx
	mov	[edi+memblock.size], ecx	;store size of new block
	mov	ebx, [usedlist]			;insert in usedlist
	mov	[edi+memblock.next], ebx
	mov	[usedlist], edi

.ok	add	edi, 8
	mov	S(0), edi
	ret
.fail	mov	S(0), dword 0
	ret



sfree:	;; ( addr -- )
	ret


	SECTION .data
;; fine-grained memory allocation area
mem_addr	dd	SALLOC_START
mem_size	dd	SALLOC_SIZE
freelist	equ	SALLOC_START
usedlist	equ	SALLOC_START+4
MIN_BLOCKSIZE	equ	64

