; start.asm - Startup code for Retro/Tunes
;
; Standalone OS usage: Called from the boot loader
; Embedded/O'Top usage: Called from a wrapper routine (typically in C)



; Test of calling C from Assembly (and vice-versa) under Linux
; Based on some examples from the NASM manual, chapter 8: Interfacing w/ C

%include "macros.inc"

        segment .text

        extern printf

	extern EMIT, KEY

;object Startup, "Startup"

        global start
start:
	;Called from C
        push    ebp
        mov     ebp, esp
;        sub     ebp, 0x4       ;Skip 64 bytes local stack space
        mov     ebx, [esp+8]    ;Get 1st parameter

	; Need to Switch to Forth conventions - Dual stacks, Heap


;Allocate memory
	extern malloc
	push	dword 0x10000
	call	malloc
	add	esp, byte 4
	mov	[RAM], eax

;Report on memory allocated
	push	eax
	push	dword addrstr
	call	printf
	add	esp, byte 8

;Clear memory (this was just a test)
	mov	ecx, 0x10000/4
	mov	edi, [RAM]
	mov	eax, 0
	cld
	rep	stosd
	

;Some Tests...

	;Say "A<cr>"
	push	dword 'A'
	call	EMIT
	add	esp, byte 4

	push	dword 10
	call	EMIT
	add	esp, byte 4

	;Wait for keypress
	call	KEY

	;Call a C function
        push    ebx
;        push    dword [myint]
        push    dword mystr
        call    printf
        add     esp, byte 8


	;Switch back to C conventions
	;Restore esp & ebp

	;Return to C
        leave   ;mov esp, ebp   pop ebp
        ret


        segment .data
myint   dd 1234
mystr   db 'Parameter = %d', 10, 0

RAM	dd 0		;RAM area used by Store Manager
addrstr db 'Allocated 64kb at %p', 10, 0


end Startup
